stages:
  - test
  - build
  - version
  - deploy

variables:
  DEPLOYMENT_PROJECT: gitlab-private/gl-security/engineering-and-research/automation-team/kubernetes/secauto/example-service-python
  DOCKER_TLS_CERTDIR: "/certs"
  CONTAINER_IMAGE_COMMIT: $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA
  CONTAINER_IMAGE_LATEST: $CI_REGISTRY_IMAGE:latest
  IMAGE_TAG: $CI_COMMIT_SHORT_SHA # Image tag for deployment pipeline

# GitLab Secure
# https://docs.gitlab.com/ee/user/application_security/

include:
  - template: Security/Dependency-Scanning.gitlab-ci.yml
  - template: Security/License-Scanning.gitlab-ci.yml
  - template: Security/SAST.gitlab-ci.yml
  - template: Security/Secret-Detection.gitlab-ci.yml

# Templates

.docker_job:
  image: docker:24-git
  services:
    - docker:24-dind
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY

.python_job:
  image: python:3.11 # See .python-version
  before_script:
    - pip install -qq pipenv

# Jobs

style_and_tests:
  extends: .python_job
  stage: test
  script:
    - pipenv sync --dev
    - pipenv run pycodestyle .
    - pipenv run pytest -W ignore::DeprecationWarning

build:
  extends: .docker_job
  stage: build
  script:
    - docker build --pull --tag $CONTAINER_IMAGE_COMMIT .
    - docker push $CONTAINER_IMAGE_COMMIT
  rules:
    - if: $CI_COMMIT_BRANCH != null

version_latest:
  extends: .docker_job
  stage: version
  script:
    - docker pull $CONTAINER_IMAGE_COMMIT
    - docker tag $CONTAINER_IMAGE_COMMIT $CONTAINER_IMAGE_LATEST
    - docker push $CONTAINER_IMAGE_LATEST
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH

deploy:
  stage: deploy
  trigger: $DEPLOYMENT_PROJECT
  rules:
    - if: $DEPLOY_STOP != null
      when: never
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
